/**
 * h-demi - h function for Vue 2 and 3
 *
 * @see {@link https://github.com/vueuse/vue-demi/issues/65}
 * @experimental
 */
import { type VNode, type VNodeChildren, type VNodeData } from 'vue-demi';
/**
 * hDemi function.
 *
 * @param type - Tag name etc
 * @param options - VNode data.
 * @param children - Children dom or VNode component
 */
declare const h: (type: string | Record<any, any>, options?: VNodeData, children?: VNodeChildren) => VNode;
/**
 * slots
 *
 * @param defaultSlots -
 */
declare const slot: (defaultSlots: any) => any;
export { h, slot };
//# sourceMappingURL=h-demi.d.ts.map