import { type PropType, type Ref } from 'vue-demi';
/**
 * Teleport Component.
 *
 * Original version by Mechazawa's 'vue2-teleport.
 * Composition api version By Logue.
 */
export declare const Teleport: import("vue-demi").DefineComponent<{
    to: {
        type: StringConstructor;
        required: true;
    };
    where: {
        type: PropType<"after" | "before">;
        default: string;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
}, {
    teleport: Ref<HTMLDivElement | undefined>;
    nodes: Ref<Node[]>;
    waiting: Ref<boolean>;
    observer: Ref<MutationObserver | null>;
    parent: Ref<ParentNode | null>;
}, {}, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, {}, string, Readonly<import("vue-demi").ExtractPropTypes<{
    to: {
        type: StringConstructor;
        required: true;
    };
    where: {
        type: PropType<"after" | "before">;
        default: string;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
}>>, {
    where: "after" | "before";
    disabled: boolean;
}>;
declare const install: (app: any) => void;
export { Teleport as default, install };
//# sourceMappingURL=teleport.d.ts.map