/**
 * @longmo/vue2-helpers
 *
 * @description A util package to use Vue 2 with Composition API easily
 * @version 2.3.0
 * @license Apache-2.0
 * @see {@link https://github.com/longmo/vue2-helpers#readme}
 *
 * Build: 2024-11-09T16:04:27.360Z
 */
!function(e,l){"object"==typeof exports&&"undefined"!=typeof module?l(exports,require("vue-demi")):"function"==typeof define&&define.amd?define(["exports","vue-demi"],l):l((e="undefined"!=typeof globalThis?globalThis:e||self).teleport={},e.VueDemi)}(this,(function(e,l){"use strict";const t=(e,t={},n=void 0)=>{if(l.isVue2)return l.h(e,t,n);const r=t.on?(e=>e?Object.entries(e).reduce(((e,[l,t])=>({...e,[l=`on${l=l.charAt(0).toUpperCase()+l.slice(1)}`]:t})),{}):{})(t.on):{};return l.h(e,{...t.props,...t.domProps,...r},n)},n=l.defineComponent({name:"Teleport",props:{to:{type:String,required:!0},where:{type:String,default:"after"},disabled:{type:Boolean,default:!1}},setup(e,t){const n=l.ref(),r=l.ref([]),u=l.ref(!1),o=l.ref(null),a=l.ref(null),d=l.ref(null);l.watch((()=>e.to),(()=>{i()})),l.watch((()=>e.where),(()=>{i()})),l.watch((()=>e.disabled),(e=>{e?(v(),f()):(p(),s())})),l.onMounted((()=>{null!=n.value&&(r.value=Array.from(n.value.childNodes)),e.disabled||p(),i()})),l.onBeforeUnmount((()=>{v(),f()}));const i=()=>{e.disabled||s()},s=()=>{if(u.value=!1,d.value=document.querySelector(e.to),null==d.value)return v(),void(u.value=!0);"before"===e.where?d.value.prepend(c()):d.value.appendChild(c())},v=()=>{n.value?.appendChild(c()),d.value=null},c=()=>{const e=document.createDocumentFragment();return r.value.forEach((l=>e.appendChild(l))),e},p=()=>{null==o.value&&(o.value=new MutationObserver((l=>{(l=>{let t=!1;l.forEach((l=>{const n=Array.from(l.addedNodes).filter((e=>!r.value.includes(e)));null!=d.value&&Array.from(l.removedNodes).includes(d.value)?(v(),u.value=!e.disabled):u.value&&n.length>0&&(t=!0)})),t&&s()})(l)})),o.value.observe(document.body,{childList:!0,subtree:!0,attributes:!1,characterData:!1})),null==a.value&&(a.value=new MutationObserver((e=>{null!=e.find((e=>e.target===n.value))&&null!=n.value&&(r.value=Array.from(n.value.childNodes),i())})))},f=()=>{null!=o.value&&(o.value.disconnect(),o.value=null),null!=a.value&&(a.value.disconnect(),a.value=null)};return{teleport:n,nodes:r,waiting:u,observer:o,parent:d}},render(){return t("div",{ref:"teleport",class:"vue-teleport",style:this.$props.disabled?"":"visibility: hidden; display: none;"},this.$slots.default)}});e.Teleport=n,e.default=n,e.install=e=>e.component("Teleport",n),Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=teleport.umd.js.map
