/**
 * @longmo/vue2-helpers
 *
 * @description A util package to use Vue 2 with Composition API easily
 * @version 2.3.0
 * @license Apache-2.0
 * @see {@link https://github.com/longmo/vue2-helpers#readme}
 *
 * Build: 2024-11-09T16:04:27.360Z
 */
!function(e,l){"use strict";const t=(e,t={},r=void 0)=>{if(l.isVue2)return l.h(e,t,r);const u=t.on?(e=>e?Object.entries(e).reduce(((e,[l,t])=>({...e,[l=`on${l=l.charAt(0).toUpperCase()+l.slice(1)}`]:t})),{}):{})(t.on):{};return l.h(e,{...t.props,...t.domProps,...u},r)},r=l.defineComponent({name:"Teleport",props:{to:{type:String,required:!0},where:{type:String,default:"after"},disabled:{type:Boolean,default:!1}},setup(e,t){const r=l.ref(),u=l.ref([]),n=l.ref(!1),a=l.ref(null),o=l.ref(null),d=l.ref(null);l.watch((()=>e.to),(()=>{s()})),l.watch((()=>e.where),(()=>{s()})),l.watch((()=>e.disabled),(e=>{e?(v(),f()):(p(),i())})),l.onMounted((()=>{null!=r.value&&(u.value=Array.from(r.value.childNodes)),e.disabled||p(),s()})),l.onBeforeUnmount((()=>{v(),f()}));const s=()=>{e.disabled||i()},i=()=>{if(n.value=!1,d.value=document.querySelector(e.to),null==d.value)return v(),void(n.value=!0);"before"===e.where?d.value.prepend(c()):d.value.appendChild(c())},v=()=>{r.value?.appendChild(c()),d.value=null},c=()=>{const e=document.createDocumentFragment();return u.value.forEach((l=>e.appendChild(l))),e},p=()=>{null==a.value&&(a.value=new MutationObserver((l=>{(l=>{let t=!1;l.forEach((l=>{const r=Array.from(l.addedNodes).filter((e=>!u.value.includes(e)));null!=d.value&&Array.from(l.removedNodes).includes(d.value)?(v(),n.value=!e.disabled):n.value&&r.length>0&&(t=!0)})),t&&i()})(l)})),a.value.observe(document.body,{childList:!0,subtree:!0,attributes:!1,characterData:!1})),null==o.value&&(o.value=new MutationObserver((e=>{null!=e.find((e=>e.target===r.value))&&null!=r.value&&(u.value=Array.from(r.value.childNodes),s())})))},f=()=>{null!=a.value&&(a.value.disconnect(),a.value=null),null!=o.value&&(o.value.disconnect(),o.value=null)};return{teleport:r,nodes:u,waiting:n,observer:a,parent:d}},render(){return t("div",{ref:"teleport",class:"vue-teleport",style:this.$props.disabled?"":"visibility: hidden; display: none;"},this.$slots.default)}});e.Teleport=r,e.default=r,e.install=e=>e.component("Teleport",r),Object.defineProperty(e,"__esModule",{value:!0})}(this.teleport=this.teleport||{},VueDemi);
//# sourceMappingURL=teleport.iife.js.map
